; Disassembly of the file "STWEEK.BIN" Sound Tweaker
;
; CPU Type: Z80 for the Bally Home Library Computer
;
; Created with dZ80 1.50 with a ton of hand editing
; and excellent commenting done by Richard C. Degler
;
; From Scratch, Saturday, 07 of June 2008 at 08:05 PM
;

; ********************* Unofficial Program Definition:
; Stweek (Sound Tweeker) - Never officially released.  Word has it that
; Scott Norris used this for programming sound for the DNA (BALLY) carts.
;
; ********************* and from the Bally/Astrocade FAQ:
;
; Stweek
;      New Image                                        2K cart
; This is not a game, it's a "Sound Tweeker" program that gives direct access to
; the music "registers." It was used as an in-house programming tool to make
; sound effects and music for other cartridges. A keypad overlay should exist,
; but it has not turned up yet. Documentation and an overlay would make this
; program very useful for home-brewers (and the Astrocade MESS emulation author)
; Written by Scot L. Norris.
;

        NOLIST
        INCLUDE "HVGLIB.H"

; ********************* Defines for Variables
L4938   EQU     $4938         ; Top of Music Stack
L4988   EQU     $4988         ; BUFFER and Top of STACK

L4D47   EQU     $4D47         ; End of Text BUFFER Array
L4D48   EQU     $4D48         ; Music Score Start - MUST be "Vxx"
L4D49   EQU     $4D49         ; ... for Voices to start with
L4D4A   EQU     $4D4A         ; Build Music Score here to $4EFF

L4F00   EQU     $4F00         ; Port Bank = 4 or toggle to 8
L4F01   EQU     $4F01         ; Sound Block start
L4F08   EQU     $4F08         ; Sound Block end
L4F09   EQU     $4F09         ; Port Number last operated on
L4F0A   EQU     $4F0A         ; Enable Knobs 3 and 4 (in either mode)
L4F0B   EQU     $4F0B         ; Save Cursor Location while Analizing
L4F0D   EQU     $4F0D         ; Last Text Character Entered
L4F0E   EQU     $4F0E         ; Temporary Storage byte
L4F10   EQU     $4F10         ; X and Y Cursor Screen Locations
L4F12   EQU     $4F12         ; Pointer to Text CHARACTER word
L4F14   EQU     $4F14         ; Pointer to Music Score Location
L4F16   EQU     $4F16         ; Base Character Address to Display
L4F18   EQU     $4F18         ; Text Flags: Bit 1 = Score Being Analyzed
                              ; Bit 2 = Text has now been Edited
                              ; Bit 3 = Knob 1 turned to the Right
                              ; Bits 4 & 5 = Not Used
                              ; Bit 6 = White Shift, Bit 7 = Mode
L4F19   EQU     $4F19         ; First Work Area cleared by . routine
                              ; Count plus 15 Text pointer addresses
L4F38   EQU     $4F38         ; Second Work Area for handling Calls and Jumps
                              ; Count plus 35 Score pointer addresses
L4F7F   EQU     $4F7F         ; Third Work Area for ASCII labels to $4FCB
                              ; Count plus 25 ID bytes and addresses

        LIST
        ORG     FIRSTC

; ********************* First Address in Cartridge
; L2000:
        DB      'U'		; $55 Menu Sentinal

        DW      MENUST		; System Menu Start Node
        DW      L21BA		; Text String "STWEEK"
        DW      L2007		; do STWEEK Start

; ********************* Do STWEEK here
L2007:  DI                    ; Disable Interrupts
        LD      SP,L4988
        SYSSUK  COLSET        ; set Colors ONCE
        DW      L2057

        SYSSUK  FILL          ; Clear Screen first 57 lines
        DW      NORMEM
        DW      $08E8         ; $4000 through $48E7
        DB      $00

        SYSSUK  FILL          ; clear Sound Block
        DW      L4F01
        DW      $0018         ; $4F01 through $4F18
        DB      $00

        LD      A,$04
        LD      (L4F00),A     ; set Port Bank to 4
        LD      A,$72
        OUT     (VERBL),A     ; 57 lines before blanking
        XOR     A
        LD      (CT0),A       ; clear $4FD5 for Debounce Timer
        SYSTEM  ACTINT

        LD      HL,$4988
        LD      (L4F12),HL    ; set $4F12 to Start of Text Buffer
        LD      DE,$0000
        LD      (L4F10),DE    ; clear $4F10 for Cursor Locations
        LD      (L4F16),HL    ; set Text Display to BUFFER start
        SYSSUK  FILL          ; prefill Text Buffer
        DW      L4988         ; $4988 through $4D47
        DW      $03C0
        DB      $20           ; with Spaces

        CALL    L20B9         ; to Initialize Mode and Display
L2046:  LD      HL,L2046      ; Sentry Return Address
        PUSH    HL            ; ... goes onto STACK
        SYSSUK  SENTRY
        DW      L2053         ; Key Mask address

        SYSSUK  DOIT
        DW      L2077         ; DO IT table address

        RET                   ; loop to L2046

; ********************* ALL KEY Keypad Mask table
L2053:  DB      $3F
        DB      $3F
        DB      $3F
        DB      $3F

; ********************* Color Table #1
L2057:  DB      $63           ; COL3L is RED
        DB      $07           ; COL2L is WHITE
        DB      $00           ; COL1L is BLACK
        DB      $07           ; COL0L and Border is WHITE

        DB      $00           ; COL3R is BLACK (not shown)
        DB      $07           ; COL2R is WHITE
        DB      $00           ; COL1R is BLACK
        DB      $07           ; COL0R is WHITE

; ********************* Pre-Formatted Strings #1 and #2
L205F:  DB      $4D,$69,$18,$41,$69,$2C         ; "M", X=24, "A", X=44,
        DB      $42,$69,$40,$43,$00             ; ... "B", X=64, "C", 0

L206A:  DB      $56,$69,$64,$4D,$43,$69,$78     ; "V", X=100, "MC" X=120,
        DB      $42,$41,$69,$90,$4E,$00         ; ... "BA" X=144, "N", 0

; ********************* DO IT table by Sentry Return codes
L2077:  DB      SP0           ; $1C on Knob 1
        DW      L20ED

        DB      SP2           ; $1E on Knob 3
        DW      L20FB

        DB      SP3           ; $1F on Knob 4
        DW      L2111

        DB      ST0           ; $14 on Trigger 1
        DW      L2215

        DB      SJ0           ; $15 on Joystick 1
        DW      L22FC

        DB      SCT0          ; $01 on Timer 1
        DW      L23B4

        DB      SCT1          ; $02 on Timer 2
        DW      L21B5

        DB      SKYD          ; $13 on Key Down
        DW      L2090

        DB      $C0           ; End of Do It table marker

; ********************* Handle Key Pad Input routine
L2090:  DEC     B             ; ... on Sentry Return = KEY DOWN
        LD      HL,L4F18
        LD      A,B           ; 0 through 23
        CP      $13           ; is it '+' ?
        JR      Z,L20D7                 ; (+$3e)
        BIT     7,(HL)        ; is Text Editor Mode set ?
        JR      NZ,L20AA                ; (+$0d)
        CP      $14           ; is it NOT 'cE' ?
        JR      NZ,L20E0                ; (+$3f)
        LD      A,(L4F00)     ; ... on Key Down = 'cE'
        XOR     $0C           ; toggle from 4 to 8
        LD      (L4F00),A     ; and Change Port Bank
        RET

; ********************* Text Editor Input continued
L20AA:  CP      $16           ; is it '.' (to Analyze) ?
        JP      Z,L23F0
        CP      $17           ; is it '=' ?
        JP      Z,L275F       ; then Play Music Score
        SET     2,(HL)        ; else set TEXT EDITED Flag
        JP      L21C1         ; ... for all other keys

; ********************* Initialize Text Editor routine
L20B9:  LD      A,(L4F18)
        XOR     $80
        LD      (L4F18),A     ; set Mode to Text Editor
        CALL    L226E         ; to Print Character on Black
        LD      HL,(L4F16)    ; First Line to Display
        LD      DE,$0000      ; Upper Left corner
L20CA:  LD      A,(HL)
        SYSTEM  CHRDIS        ; and Display a Character

        INC     HL            ; Next Character
        LD      A,D
        CP      $28           ; is Not Right Side of Screen yet ?
        JR      NZ,L20CA                ; (-$09)
        CALL    L227B         ; to Print Character on Red
        RET

; ********************* Change Input Mode routine
L20D7:  LD      A,(L4F18)     ; ... on Key Down = '+'
        XOR     $80           ; toggle Bit 7, 0 = Port mode
        LD      (L4F18),A     ; ... and 1 = Text Buffer mode
        RET

; ********************* Port Mode Input continued
L20E0:  CP      $17           ; is it Not '=' ?
        JR      NZ,L212B                ; (+$47)
        LD      A,(L4F0A)     ; ... on Key Down = '='
        XOR     $01
        LD      (L4F0A),A     ; toggle Enable Knobs 3 and 4
        RET

; ********************* Select Insert / Delete routine
L20ED:  LD      HL,L4F18      ; ... on Sentry Return = KNOB 1
        LD      A,$7C
        SUB     B
        JR      C,L20F8                 ; (+$03)
        SET     3,(HL)        ; on Less than 124
        RET

L20F8:  RES     3,(HL)        ; on 125 or More
        RET

; ********************* Change Left Digit routine
L20FB:  LD      A,(L4F0A)     ; ... on Sentry Return = KNOB 3
        CP      $01           ; is Knob Control enabled ?
        RET     NZ
        LD      A,(L4F09)     ; get current Port Number
        SYSSUK  INDEXB
        DW      L4F01         ; get Port Number address

        AND     $0F           ; what WAS the lower half
        LD      (HL),A
        LD      A,B           ; Knob 3 is NEW upper half
        AND     $F0
        OR      (HL)          ; save BBBBaaaa for Port
        JR      L2179                   ; (+$68)

; ********************* Change Right Digit routine
L2111:  LD      A,(L4F0A)     ; ... on Sentry Return = KNOB 4
        CP      $01           ; is Knob Control enabled ?
        RET     NZ
        LD      A,(L4F09)     ; get current Port Number
        SYSSUK  INDEXB
        DW      L4F01         ; get Port Number address

        AND     $F0           ; what WAS the upper half
        LD      (HL),A
        LD      A,B           ; Knob 4 will be lower half
        AND     $F0
        RRCA                  ; ... after dividing by 16
        RRCA
        RRCA
        RRCA
        OR      (HL)          ; save aaaaBBBB for Port
        JR      L2179                   ; (+$4e)

; ********************* Port Mode Input finish
L212B:  PUSH    BC            ; ... on Key Down = other
        PUSH    DE
        PUSH    AF
        LD      A,(L4F00)
        CP      $08           ; is Port 4-to-7 selected ?
        JR      Z,L2145                 ; (+$10)
        SYSSUK  RECTAN
        DB      $00           ; X = 0
        DB      $27           ; Y = 39
        DB      $9F           ; W = 159
        DB      $09           ; H = 9
        DB      $FF           ; Color mask = RED

        SYSSUK  STRDIS
        DB      $54           ; X = 84 for Right Half
        DB      $28           ; Y = 40
        DB      $01           ; Options = WHITE on BLACK
        DW      L206A         ; String address #2

        JR      L2153                   ; (+$0e)

L2145:  SYSSUK  RECTAN
        DB      $00           ; X = same as above
        DB      $27           ; Y
        DB      $9F           ; W
        DB      $09           ; H
        DB      $FF           ; Color mask = RED

        SYSSUK  STRDIS
        DB      $04           ; X = 4 for Left Half
        DB      $28           ; Y = 40
        DB      $01           ; Options = WHITE on BLACK
        DW      L205F         ; String address #1

L2153:  POP     AF            ; restore Key value
        POP     DE
        POP     BC
        RRCA                  ; divide by 4 for Row
        RRCA
        AND     $03           ; Keypad row MOD 4
        SYSSUK  INDEXB
        DW      L21B1         ; offset 0, 1, 2, 3

        EX      DE,HL         ; stash Port QUANTUM
        LD      A,B
        AND     $03           ; Keypad column MOD 4
        LD      C,A           ; hold as 0, 1, 2, 3
        LD      A,(L4F00)     ; Port Shift 4 or 8
        DEC     A
        SUB     C             ; 3,2,1,0 or 7,6,5,4
        LD      (L4F09),A     ; Port Number to change
        SYSSUK  INDEXB
        DW      L4F01         ; Port Address base

        LD      A,(DE)        ; Quantum = 16, -16, 1, -1
        ADD     A,(HL)        ; plus OLD Port contents
        BIT     3,B           ; Key in TOP TWO rows ?
        JR      Z,L2179                 ; (+$04)
        XOR     (HL)          ; when changing RIGHT digit
        AND     $0F
        XOR     (HL)          ; ... mask out half overflow
L2179:  LD      (HL),A        ; save as NEW Port content
        LD      HL,L4F01
        LD      BC,$0818      ; 8 x Sound Block Output Port
        OTIR
        LD      A,$14
        LD      (CT1),A       ; set $4FD6 to 20 for 1/3 sec.
        LD      DE,$3000      ; start at X = 0, Y = 48
        LD      HL,L4F08
        LD      BC,$0804      ; 8 Ports, BLACK on WHITE 
L2190:  CALL    L219B         ; to Display Port Value
        DEC     HL
        LD      A,E
        ADD     A,$04         ; and bump numbers apart
        LD      E,A
        DJNZ    L2190                   ; (-$0a)
        RET

; ********************* Display Port Value subroutine
L219B:  LD      A,(HL)
        RRCA                  ; divide Value by 16
        RRCA
        RRCA
        RRCA
        CALL    L21A4         ; first show LEFT nibble
        LD      A,(HL)        ; re-load for RIGHT nibble
L21A4:  AND     $0F
        CP      $0A           ; DAA not needed ?
        JR      C,L21AC                 ; (+$02)
        ADD     A,$07
L21AC:  ADD     A,$30         ; make into ASCII
        SYSTEM  CHRDIS

        RET

; ********************* Keypad Row Quantum table
L21B1:  DB      $10           ; + 16
        DB      $F0           ; - 16
        DB      $01           ; + 1
        DB      $FF           ; - 1

; ********************* Keyboard De-Bounce routine
L21B5:  XOR     A             ; ... on Sentry Return = TIMER 2
        LD      (KEYSEX),A    ; Clear $4FE3 Keyboard Tracking byte
        RET

; ********************* "STWEEK" text string
L21BA:  DB      'S','T','W','E','E','K',$00

; ********************* Input Character to Text Buffer finish
L21C1:  LD      HL,L4F18      ; ... on KEY DOWN = other
        BIT     6,(HL)        ; is White Shift ON ?
        JR      NZ,L220B                ; (+$43)
        CALL    L23B9         ; to Look Up Key-to-ASCII Un-SHIFTed
        CP      $58           ; as found on "cE" ONLY ?
        JR      Z,L2205                 ; (+$36)
L21CF:  LD      (L4F0D),A     ; save Lookup value
        LD      DE,L4D47
        LD      HL,(L4F12)    ; get Text Character pointer
        DEC     DE
        SBC     HL,DE         ; End of Buffer reached ?
        JR      NC,L2201                ; (+$24)
        CALL    L226E         ; to Print Character on Black
        LD      A,(L4F0D)     ; read Lookup value
        LD      C,$01
        LD      DE,(L4F10)    ; current Print XY Location
        SYSTEM  CHRDIS        ; Print same Character on Black

        LD      (L4F10),DE    ; save Next Print XY
        LD      HL,(L4F12)
        LD      (HL),A        ; save Character in Text BUFFER
        INC     HL
        LD      (L4F12),HL    ; save Next Text Character pointer
        LD      DE,(L4F10)    ; XY again (was already there)
        LD      A,D
        CP      $28           ; is Cursor past End-Of-Line ?
        CALL    Z,L2382       ; to Scroll Display to Next Line
L2201:  CALL    L227B         ; to Print Character on Red
        RET

; ********************* Set White Shift in TEXT Mode only
L2205:  LD      HL,L4F18      ; ... on key "cE"
        SET     6,(HL)        ; set WHITE SHIFT Mode ON
        RET

; ********************* Do All Other Keys AFTER White Shift
L220B:  RES     6,(HL)        ; Clear WHITE SHIFT Bit
        LD      HL,L23DA      ; use Key-to-ASCII Table 2
        CALL    L23BC         ; to Look up SHIFTED keys
        JR      L21CF                   ; (-$46)

; ********************* Insert Space or Delete Character routine
L2215:  BIT     CHTRIG,B      ; ... on Sentry Return = TRIGGER 1
        JR      Z,L225B                 ; (+$42)
        CALL    L226E         ; to Print Character on Black
        LD      HL,L4F18
        SET     7,(HL)        ; Back into Text Edit mode
        SET     2,(HL)        ; mark Text as been EDITED
        LD      HL,L4D47      ; End of Text Buffer
        LD      DE,(L4F12)    ; get Text Character pointer
        JR      NC,L222D                ; (+$01)
        CCF                   ; (always clear Carry flag)
L222D:  SBC     HL,DE         ; Byte count difference
        LD      B,H
        LD      C,L           ; hold Count to Buffer End
        LD      HL,L4F18
        BIT     3,(HL)        ; Knob 1 turned to the Right ?
        JR      NZ,L225C                ; (+$24)
; ********************* Insert Space at Text Cursor continued
        LD      DE,L4D47      ; ... all the way to the End
        LD      HL,L4D47
        DEC     HL
        LDDR                  ; shift Text Array over Right
        INC     HL
        LD      (HL),$20      ; save Space as New Character
; ********************* Insert Space or Delete Character finish
L2244:  LD      DE,(L4F10)
        LD      C,$01         ; in WHITE on BLACK Color 1
L224A:  LD      A,(HL)
        SYSTEM  CHRDIS

        INC     HL            ; Next Character to Print
        LD      A,D
        CP      $28           ; is Not End of Line yet ?
        JR      NZ,L224A                ; (-$09)
        CALL    L227B         ; to Print Character on Red
        LD      A,$08
        LD      (CT0),A       ; Set $4FD5 to 8 for debounce
L225B:  RET

; ********************* Delete Character under Cursor continued
L225C:  LD      DE,(L4F12)    ; ... on Knob 1 turned Right
        LD      HL,(L4F12)
        INC     HL
        LDIR                  ; shift Text Array over Left
        DEC     HL
        LD      (HL),$20      ; save Space as New End-of-Buffer
        LD      HL,(L4F12)
        JR      L2244                   ; (-$2a)

; ********************* Print a Text Character subroutine
L226E:  LD      DE,(L4F10)    ; get Current Cursor location
        LD      HL,(L4F12)    ; get Text Character pointer
        LD      A,(HL)
        LD      C,$01         ; in WHITE on BLACK Color 1
        SYSTEM  CHRDIS

        RET

; ********************* Print Cursor Character subroutine
L227B:  LD      DE,(L4F10)    ; get Current Cursor location
        LD      C,$03
        LD      HL,(L4F12)    ; get Text Character pointer
        LD      A,(HL)
        SYSTEM  CHRDIS        ; in WHITE on RED Color 3

        RET

; ********************* Move Cursor on Joystick 1 = Right
L2288:  CALL    L226E         ; to Print Character on Black
        LD      DE,L4D47
        SBC     HL,DE         ; at End of Buffer already ?
        JR      NC,L22B6                ; (+$24)
        LD      HL,(L4F12)
        INC     HL
        LD      (L4F12),HL    ; point at Next Text Character
        LD      HL,(L4F10)    ; read Cursor XY screen location
        LD      DE,$0008
        ADD     HL,DE         ; move Cursor to the Right
        LD      (L4F10),HL    ; ... and save Cursor XY location
        LD      A,L
        CP      $A0           ; is NOT past End of Line ?
        JR      NZ,L22B6                ; (+$0e)
        LD      L,$00         ; move Cursor to Start of Line
        LD      A,H
        ADD     A,$08         ; move Cursor Down a Line
        LD      H,A
        LD      (L4F10),HL    ; ... and save Cursor XY location
        CP      $28           ; is Too Low past Bottom Line ?
        CALL    Z,L2382       ; to Scroll Display to Next Line
L22B6:  LD      A,$0C
        LD      (CT0),A       ; Set $4FD5 to 12 for debounce
        CALL    L227B         ; to Print Character on Red
        JR      L2308                   ; (+$48)

; ********************* Move Cursor on Joystick 1 = Left
L22C0:  CALL    L226E         ; to Print Character on Black
        LD      DE,L4988
        DEC     HL
        SBC     HL,DE         ; at Start of Buffer already ?
        JR      C,L22F2                 ; (+$27)
        LD      HL,(L4F12)
        DEC     HL
        LD      (L4F12),HL    ; point at Previous Text Character
        LD      HL,(L4F10)    ; read Cursor XY screen location
        LD      A,L
        CP      $00           ; is NOT at Start of Line
        JR      NZ,L22EA                ; (+$10)
        LD      L,$98         ; move Cursor to End of Line
        LD      A,H
        SUB     $08           ; move Cursor Up a Line
        LD      H,A
        LD      (L4F10),HL    ; ... and save Cursor XY location
        CP      $F8           ; is Too High above Top Line ?
        CALL    Z,L2391       ; to Scroll Display to Previous Line
        JR      L22F2                   ; (+$08)

L22EA:  LD      DE,$0008
        SBC     HL,DE         ; move Cursor to the Left
        LD      (L4F10),HL    ; ... and save Cursor XY location
L22F2:  LD      A,$0C
        LD      (CT0),A       ; Set $4FD5 to 12 for debounce
        CALL    L227B         ; to Print Character on Red
        JR      L230D                   ; (+$11)

; ********************* Move Red Text Cursor and Debounce routine(s)
L22FC:  LD      HL,L4F18      ; ... on Sentry Return = JOYSTICK 1
        BIT     1,(HL)        ; has Score been Analyzed ?
        JR      NZ,L2315                ; (+$12)
        BIT     CHRIGH,B
        JP      NZ,L2288      ; (could be a CALL instead ??)
L2308:  BIT     CHLEFT,B
        JP      NZ,L22C0      ; (could be a CALL instead ??)
L230D:  BIT     CHUP,B
        JR      NZ,L2316                ; (+$05)
        BIT     CHDOWN,B
        JR      NZ,L2351                ; (+$3c)
L2315:  RET

; ********************* Move Cursor on Joystick 1 = Up
L2316:  CALL    L226E         ; to Print Character on Black
        LD      DE,L4988      ; Start of Text Buffer
        LD      HL,$0014
        ADD     HL,DE
        LD      DE,(L4F12)    ; get Current Character pointer
        EX      DE,HL         ; swap Current and Buffer+20
        JR      NC,L2328                ; (+$01)
        CCF                   ; (always clear Carry flag)
L2328:  SBC     HL,DE         ; is in Top Row already ?
        JR      C,L2348                 ; (+$1c)
        LD      HL,(L4F12)    ; get Current location again
        LD      DE,$0014
        SBC     HL,DE
        LD      (L4F12),HL    ; point at Current Character - 20
        LD      HL,(L4F10)    ; read Cursor XY screen location
        LD      DE,$0800
        SBC     HL,DE         ; move Cursor Up a Line
        LD      (L4F10),HL    ; ... and save Cursor XY location
        LD      A,H
        CP      $F8           ; is Too High above Top Line ?
        CALL    Z,L2391       ; to Scroll Display to Previous Line
L2348:  LD      A,$0C
        LD      (CT0),A       ; Set $4FD5 to 12 for debounce
        CALL    L227B         ; to Print Character on Red
        RET

; ********************* Move Cursor on Joystick 1 = Down
L2351:  CALL    L226E         ; to Print Character on Black
        LD      DE,$0013
        ADD     HL,DE         ; Current Character + 1 location + 19
        LD      DE,L4D47      ; compare to End of Text Buffer
        SBC     HL,DE         ; is in Bottom Row already ?
        JR      NC,L2379                ; (+$1a)
        LD      HL,(L4F12)    ; get Current Character pointer
        LD      DE,$0014
        ADD     HL,DE
        LD      (L4F12),HL    ; point at Current Character + 20
        LD      HL,(L4F10)    ; read Cursor XY screen location
        LD      DE,$0800
        ADD     HL,DE         ; move Cursor Down a Line
        LD      (L4F10),HL    ; ... and save Cursor XY location
        LD      A,H
        CP      $28           ; is Too Low past Bottom Line ?
        CALL    Z,L2382       ; to Scroll Display to Next Line
L2379:  LD      A,$14
        LD      (CT0),A       ; Set $4FD5 to 20 for debounce
        CALL    L227B         ; to Print Character on Red
        RET

; ********************* Scroll Display to Next Line Down subroutine
L2382:  LD      HL,(L4F10)    ; read Cursor XY screen location
        LD      A,H
        SUB     $08           ; move Cursor Up a Line
        LD      H,A
        LD      (L4F10),HL    ; ... and save Cursor XY location
        LD      DE,$0014      ; hold a positive twenty
        JR      L239E                   ; (+$0d)

; ********************* Scroll Display to Previous Line Up subroutine
L2391:  LD      HL,(L4F10)    ; read Cursor XY screen location
        LD      DE,$0800
        ADD     HL,DE         ; move Cursor Down a Line
        LD      (L4F10),HL    ; ... and save Cursor XY location
        LD      DE,$FFEC      ; hold a negative twenty
; ********************* Scroll Display Up/Down subroutines finish
L239E:  LD      HL,(L4F16)    ; First Character to Display
        ADD     HL,DE
        LD      (L4F16),HL    ; Display will be Moved +/- a Row
        LD      C,$01
        LD      DE,$0000      ; Upper Left Screen Location
L23AA:  LD      A,(HL)
        SYSTEM  CHRDIS        ; Print Another Character on Black

        INC     HL            ; Next Character (Wrap when needed)
        LD      A,D
        CP      $28           ; Not Bottom of Screen yet ?
        JR      NZ,L23AA                ; (-$09)
        RET

; ********************* Joystick De-Bounce routine
L23B4:  XOR     A             ; ... on Sentry Return = TIMER 1
        LD      (OSW0),A      ; Clear $4FE4 Switch 0 Tracking Byte
        RET

; ********************* Look Up ASCII for Key routine
L23B9:  LD      HL,L23C2      ; ... from UN-SHIFTED Key table
L23BC:  LD      C,A           ; or enter here for SHIFTED Keys
        LD      B,$00
        ADD     HL,BC
        LD      A,(HL)        ; (INDEXB would have worked here)
        RET

; ********************* Other UN-Shifted Keys table
L23C2:  DB      $56,$4D,$4C,$20     ; V M L (space)
        DB      $51,$43,$4E,$3A     ; Q C N :
        DB      $37,$38,$39,$5F     ; 7 8 9 <-
        DB      $34,$35,$36,$20     ; 4 5 6 (space)
        DB      $31,$32,$33,$2A     ; 1 2 3 (unused *)
        DB      $58,$30,$20,$20     ; X 0 (unused spaces)

; ********************* White Shifted Keys (and Spaces)
L23DA:  DB      $52,$54,$4F,$20     ; R T O
        DB      $50,$5E,$4A,$20     ; P ^ J
        DB      $47,$48,$5A,$20     ; G H Z
        DB      $44,$45,$46,$20     ; D E F
        DB      $41,$42,$43,$20     ; A B C
        DB      $20,$53      ; (Cancel) S

; ********************* Analyze Text (Only in Text Editor mode) subroutine
L23F0:  LD      HL,L4F18      ; ... on Key Down = '.'
        BIT     1,(HL)        ; is Text already Being Analyzed ?
        RET     NZ            ; then bail out
        BIT     2,(HL)        ; is there no EDITED text?
        JP      Z,L275F       ; then go Play Music (all 55's ??)
        SET     1,(HL)        ; else set Text Flag as ANALYZED
        RES     2,(HL)        ; set Text Flag as NO NEW TEXT
        SYSSUK  FILL          ; clear Music Score area
        DW      L4D48         ; $4D4A - 2 to $4EFF
        DW      $01B8
        DB      $00

        SYSSUK  FILL          ; clear Music Work areas
        DW      L4F19         ; $4F19 to $4FCB
        DW      $00B3
        DB      $00

        LD      HL,L4D48      ; Music Score Start - 2 (for the "V")
        LD      (L4F14),HL    ; save as Pointer to Score Location
        LD      HL,(L4F12)
        LD      (L4F0B),HL    ; store Character pointer until done
        LD      HL,$4987
        LD      (L4F12),HL    ; set Character pointer to BUFFER - 1
L241F:  CALL    L2589         ; to Skip Spaces and Get Character
        LD      HL,L241F      ; Music Return Point
        PUSH    HL            ; ...goes onto Stack
        LD      DE,(L4F14)    ; read Starting Music Score location
        LD      HL,L243D      ; Token Letters Jump Table #1 base
        LD      B,$09         ; # of un-shifted entries
L242F:  CP      (HL)          ; found it yet ?
        JR      Z,L243B                 ; (+$09)
        INC     HL
        INC     HL
        INC     HL
        INC     HL            ; try next entry
        DJNZ    L242F                   ; (-$09)
        JP      L247D         ; Else check Table #2

; ********************* Jump Table handler
L243B:  INC     HL
        JP      (HL)

; ********************* Jump Table #1 for UN-Shifted Token Letters
L243D:  DB      $56           ;  on 'V' for "Voices mask" + 00-FF
        JP      L24AC

        DB      $4D           ;  on 'M' for "Master oscillator" + 00-FF
        JP      L24DE

        DB      $4E           ;  on 'N' for "Note" + count + 00-99 + Note(s)
        JP      L24E7

        DB      $51           ;  on 'Q' for "Quit/Quiet"
        JP      L25A2

        DB      $43           ;  on 'C' for "music Call relative" + Label ID
        JP      L25B1

        DB      $4C           ;  on 'L' for "volume Levels" + 0000-3FFF
        JP      L2565

        DB      $3A           ;  on ':' for ": subroutine or label" + ID
        JP      L2617

        DB      $5F           ;  on 'left arrow' for "music call" + Label ID
        JP      L2571

        DB      $20           ;  on 'space' for "ignore this space"
        JP      L2588

; ********************* Jump Table #2 for SHIFTED Token Letters
L2461:  DB      $52           ;  on 'R' for "Rest" + 00-99 silently
        JP      L25A8

        DB      $5E           ;  on 'up arrow' for "RETurn"
        JP      L25D4

        DB      $4A           ;  on 'J' for "music Jump" + Label ID
        JP      L25DA

        DB      $50           ;  on 'P' for "Push number onto stack" + 1-16
        JP      L25F2

        DB      $5A           ;  on 'Z' for "decstackjumpnotZero" + Label ID
        JP      L25FF

        DB      $54           ;  on 'T' for "Toggle legato/stacato"
        JP      L263F

        DB      $4F           ;  on 'O' for "Output" + Port 00-x7 + Note
        JP      L2645

; ********************* continue if Token NOT in First Jump Table
L247D:  LD      HL,L2461      ; Token Letters Jump Table #2 base
        LD      B,$07         ; # of shifted entries
L2482:  CP      (HL)          ; found it yet ?
        JR      Z,L243B                 ; (-$4a)
        INC     HL
        INC     HL
        INC     HL
        INC     HL            ; try next entry
        DJNZ    L2482                   ; (-$09)
        RET                   ; if NOT in Second Jump Table

; ********************* Save A and INCREMENT Music Pointer subroutine
L248C:  PUSH    HL
        LD      HL,(L4F14)
        LD      (HL),A        ; save A
        INC     HL
        LD      (L4F14),HL    ; increment Music Pointer
        POP     HL
        RET

; ********************* Add Score Location to Work Area #2 subroutine
L2497:  LD      HL,L4F38      ; Work Area #2 counter
        LD      E,(HL)
        LD      D,$00
        INC     DE
        LD      (HL),E        ; save counter + 1
        SLA     E             ; times 2
        DEC     HL
        ADD     HL,DE         ; point to open slot
        LD      DE,(L4F14)    ; read Score pointer
        DEC     DE
        LD      (HL),E
        INC     HL
        LD      (HL),D        ; save Score pointer-1 in Work Area #2
        RET

; ********************* Set VOICE MASK plus Mask routine
L24AC:  LD      A,$90         ; ... on First Letter = $56 for "V"
        CALL    L248C         ; to Save $90 and Increment Pointer
        CALL    L24B5         ; to Get Two Bytes (00-FF) and Save
        RET

; ********************* Get Two Bytes (00-FF) and Save as One subroutine
L24B5:  CALL    L2589         ; to Skip Spaces and Get Character
        CALL    L24D1         ; to Return ASCII as Hexadecimal nibble
        SLA     A             ; times 16
        SLA     A
        SLA     A
        SLA     A
        LD      C,A           ; hold as UPPER nibble
        INC     HL
        LD      A,(HL)        ; load Next Character
        LD      (L4F12),HL    ; save new Text Character pointer
        CALL    L24D1         ; to Return ASCII as Hexadecimal nibble
        ADD     A,C           ; combine LOWER nibble
        CALL    L248C         ; to Save A and Increment Pointer
        RET

; ********************* Convert ASCII to Hexadecimal subroutine
L24D1:  JR      NC,L24D4                ; (+$01)
        CCF                   ; (always clear Carry flag)
L24D4:  SUB     $41           ; is ASCII Less Than "A" ?
        JR      C,L24DB                 ; (+$03)
        ADD     A,$0A         ; Return Letter $0A through $0F
        RET

L24DB:  ADD     A,$11         ; Return Digit $00 through $09
        RET

; ********************* Set MASTER OSCILLATOR Value routine
L24DE:  LD      A,$80         ; ... on Token Letter = $4D for "M"
        CALL    L248C         ; to Save $80 and Increment Pointer
        CALL    L24B5         ; to Get Two Bytes (00-FF) and Save
        RET     

; ********************* Set Count, Duration, and NOTE(S) Value routine
L24E7:  LD      HL,(L4F12)    ; ... on Token Letter = $4E for "N"
        INC     HL
        LD      A,(HL)        ; next character as Note Counter
        LD      (L4F12),HL    ; save new Text Character pointer
        SUB     $30
        LD      B,A           ; hold "0" as 0 for Note Counter
        CALL    L250F         ; to Get Two Bytes (00-99) and Save
L24F5:  LD      A,B           ; loop here for Counter times
        LD      (L4F0E),A     ; save counter in Temp
        CALL    L2589         ; to Skip Spaces and Get Character
        CP      $48           ; is Next Character "H" ?
        JR      Z,L2505                 ; (+$05)
        CALL    L252B         ; else to Look-Up Note Data
        JR      L2508                   ; (+$03)

; *********************  continue after "H" for Actual Value
L2505:  CALL    L24B5         ; to Get Two Bytes (00-FF) and Save
; *********************  continue here after Look-Up Note Data
L2508:  LD      A,(L4F0E)     ; restore counter from Temp
        LD      B,A
        DJNZ    L24F5                   ; (-$19)
        RET

; ********************* Get Two Bytes (00-99) and Save as One subroutine
L250F:  CALL    L2589         ; to Skip Spaces and Get Character
        SUB     $30           ; make "0" into 0
        SLA     A             ; times 2
        LD      C,A
        SLA     A             ; times 4
        SLA     A
        ADD     A,C           ; plus 2x
        LD      C,A           ; total = 10x
        INC     HL
        LD      (L4F12),HL    ; save Next Character pointer
        LD      A,(HL)        ; load New Character
        SUB     $30           ; make "0" into 0
        ADD     A,C           ; combine
        AND     $7F           ; keep it positive
        CALL    L248C         ; to Save A and Increment Pointer
        RET

; ********************* Look-Up NOTE(s) Data Conversion subroutine
L252B:  SUB     $41           ; make "A" into 0
        PUSH    HL            ; save old Text Character pointer
        LD      HL,L265E      ; Data Conversion Table base address
        LD      C,A
        SLA     C             ; times 2
        LD      B,$00
        ADD     HL,BC         ; (INDEXW would work here)
        LD      E,(HL)
        INC     HL
        LD      D,(HL)        ; Pointer to Data Block for A to G
        EX      DE,HL
        LD      B,(HL)        ; word (byte pairs) count of Block
        INC     HL
        EX      (SP),HL       ; swap Data Block and Text Character pointers
        LD      A,(HL)        ; read old Text Character value
        INC     HL
        ADD     A,(HL)        ; ... add in Text Character + 1
        LD      (L4F0D),A     ; save as Last Character Entered
        LD      A,(HL)        ; read Text Character + 1
        CP      $53           ; is it NOT "S" (was Octave number) ?
        JR      NZ,L2551                ; (+$08)
        LD      A,(L4F0D)     ; restore from Last Character Entered
        INC     HL
        ADD     A,(HL)        ; Add Character after "S" as Octave
        LD      (L4F0D),A     ; save as Last Character Entered
L2551:  LD      A,(L4F0D)     ; restore from Last Character Entered
        LD      (L4F12),HL    ; save as Text Character pointer
        POP     HL            ; restore Data Block Pointer
L2558:  INC     HL            ; next Data byte
        CP      (HL)          ; is it a Match to Accumulator ?
        JR      Z,L255F                 ; (+$03)
        INC     HL            ; else Next byte
        DJNZ    L2558                   ; (-$07)
L255F:  DEC     HL            ; back pointer up if found or fell through
        LD      A,(HL)        ; get Data byte at Match - 1
        CALL    L248C         ; to Save A and Increment Pointer
        RET

; ********************* Set LEVEL (really Volume) Values routine
L2565:  LD      A,$B0         ; ... on Token Letter = $4C for "L"
        CALL    L248C         ; to Save $B0 and Increment Pointer
        CALL    L24B5         ; to Get Two Bytes (00-FF) and Save
        CALL    L24B5         ; to Get Two More Bytes (00-FF) and Save
        RET

; ********************* Set MUSIC CALL and save ID and 00 routine
L2571:  LD      A,$CD         ; ... on Token Letter = $5F for "LEFT ARROW"
        CALL    L248C         ; to Save $CD and Increment Pointer
        CALL    L2497         ; to Add Score Location to Work Area #2
        LD      HL,(L4F12)
        INC     HL
        LD      A,(HL)        ; load New Character for Label ID
        LD      (L4F12),HL    ; increment Text Character pointer
        CALL    L248C         ; to Save A and Increment Pointer
        XOR     A
        CALL    L248C         ; to Save $00 and Increment Pointer
L2588:  RET                   ; ... on Token Letter = $20 for "SPACE"

; ********************* Skip Spaces and Get Next Character subroutine
L2589:  LD      HL,(L4F12)    ; read Current Character pointer
        LD      A,$20
        LD      DE,L4D47
L2591:  INC     HL            ; check Next Text Character
        CP      (HL)          ; is Not a SPACE ?
        JR      NZ,L259D                ; (+$08)
        SBC     HL,DE         ; is End of Text Buffer ?
        JP      NC,L26F1
        ADD     HL,DE         ; else Loop Back
        JR      L2591                   ; (-$0c)

L259D:  LD      (L4F12),HL    ; found something so save pointer
        LD      A,(HL)        ; ...  and Load non-space character
        RET

; ********************* Set QUIT/QUIET (but keep going) routine
L25A2:  LD      A,$F0         ; ... on Token Letter = $51 for "Q"
        CALL    L248C         ; to Save $F0 and Increment Pointer
        RET

; ********************* Set REST and Value routine
L25A8:  LD      A,$E1         ; ... on Token Letter = $52 for "R"
        CALL    L248C         ; to Save $E1 and Increment Pointer
        CALL    L250F         ; to Get Two Bytes (00-99) and Save
        RET

; ********************* Set Music CALL RELATIVE + 1 and ID routine
L25B1:  LD      A,$D0         ; ... on Token Letter = $43 for "C"
        CALL    L248C         ; to Save $D0 and Increment Pointer
        CALL    L2497         ; to Add Score Location to Work Area #2
        LD      HL,(L4F12)
        INC     HL
        LD      (L4F12),HL    ; increment Text Character pointer
        LD      HL,L4F19      ; Work Area #1 counter
        LD      E,(HL)
        LD      D,$00
        INC     E
        LD      (HL),E        ; save counter + 1
        SLA     E             ; times 2
        DEC     HL
        ADD     HL,DE         ; point to open slot
        LD      DE,(L4F12)    ; read Text Character pointer
        LD      (HL),E
        INC     HL
        LD      (HL),D        ; Add Text pointer to Work Area #1
        RET

; ********************* Set Music RETURN routine
L25D4:  LD      A,$C9         ; ... on Token Letter = $5E for "UP ARROW"
        CALL    L248C         ; to Save $C9 and Increment Pointer
        RET

; ********************* Set Music JUMP and ID + ?? routine
L25DA:  LD      A,$C3         ; ... on Token Letter = $4A for "J"
        CALL    L248C         ; to Save $C3 and Increment Pointer
        CALL    L2497         ; to Add Score Location to Work Area #2
        LD      HL,(L4F12)
        INC     HL
        LD      A,(HL)        ; load New Text Character for Label ID
        CALL    L248C         ; to Save ID and Increment Pointer
        CALL    L248C         ; to Save ID and Increment Pointer again
        INC     HL
        LD      (L4F12),HL    ; increment Text Character pointer TWICE ??
        RET

; ********************* Set PUSH Number (0-F) onto Music Stack routine
L25F2:  CALL    L2589         ; to Get Character ... on Token Letter = $50 for "P"
        DEC     A
        AND     $0F           ; Number - 1 to PUSH onto Music Stack
        LD      B,$A0
        ADD     A,B
        CALL    L248C         ; to Save $Ax - 1 and Increment Pointer
        RET

; ********************* Set DSJNZ and Displacement word ID + 00 routine
L25FF:  LD      A,$C0         ; ... on Token Letter = $5A for "Z"
        CALL    L248C         ; to Save $C0 and Increment Pointer
        CALL    L2497         ; to Add Score Location to Work Area #2
        LD      HL,(L4F12)
        INC     HL
        LD      (L4F12),HL    ; increment Text Character pointer
        LD      A,(HL)
        CALL    L248C         ; to Save Label ID and Increment Pointer
        XOR     A
        CALL    L248C         ; to Save $00 and Increment Pointer
        RET

; ********************* Add ID and Score Location to Work Area #3 Routine
L2617:  LD      A,(L4F7F)     ; ... on Token Letter = $3A for ":"
        INC     A
        LD      (L4F7F),A     ; increment Work Area #3 counter
        LD      DE,L4F7F      ; Work Area #3 base
        LD      B,A
        SLA     A             ; counter times 2
        ADD     A,B           ; plus 1x
        DEC     A
        DEC     A             ; minus 2
        LD      L,A           ; total = 3x - 2
        LD      H,$00
        ADD     HL,DE         ; point to open slot
        LD      DE,(L4F12)
        INC     DE
        LD      (L4F12),DE    ; increment Text Character pointer
        LD      A,(DE)
        LD      (HL),A        ; save New Character as Routine ID
        INC     HL
        LD      DE,(L4F14)    ; read Music Score pointer
        LD      (HL),E
        INC     HL
        LD      (HL),D        ; save Score pointer in Work Area #3
        RET

; ********************* Set TOGGLE Legato/Stacato mode routine
L263F:  LD      A,$E0         ; ... on Token Letter = $54 for "T"
        CALL    L248C         ; to Save $E0 and Increment Pointer
        RET

; ********************* Set OUTPUT Port (00-xF) and NOTE Value routine
L2645:  CALL    L24B5         ; to Get Two Bytes ... on Token Letter = $4F for "O"
        LD      HL,(L4F14)
        DEC     HL
        LD      A,(HL)        ; ... then UN-Save it
        LD      B,$80
        AND     $0F
        OR      B
        LD      (HL),A        ; ... and RE-save it as 1000aaaa
        CALL    L2589         ; to Skip Spaces and Get Character
        CP      $48           ; is it "H" ?
        JP      Z,L24B5       ; then Get Two Bytes (00-FF) and RETurn
        JP      L252B         ; else to Look-Up Data and RETurn

; ********************* Data NOTE Conversion Address table
L265E:  DW      L266C         ; Block #1 for "A"
        DW      L2681         ; Block #2 for "B"
        DW      L268A         ; Block #3 for "C"
        DW      L26A3         ; Block #4 for "D"
        DW      L26B8         ; Block #5 for "E"
        DW      L26C1         ; Block #6 for "F"
        DW      L26D4         ; Block #7 for "G"

; ********************* Data Count and NOTE value for ASCII blocks
L266C:  DB      $0A
        DB      $E1,$71       ; 225 for A+0
        DB      $D4,$C4       ; 212 for A+S+0
        DB      $70,$72       ; 112 for A+1
        DB      $6A,$C5       ; 106 for A+S+1
        DB      $37,$73       ; 55 for A+2
        DB      $34,$C6       ; 52 for A+S+2
        DB      $1B,$74       ; 27 for A+3
        DB      $1A,$C7       ; 26 for A+S+3
        DB      $0D,$75       ; 13 for A+4
        DB      $07,$76       ; 7 for A+5

L2681:  DB      $04
        DB      $C8,$72       ; 200 for B+0
        DB      $64,$73       ; 100 for B+1
        DB      $31,$74       ; 49 for B+2
        DB      $18,$75       ; 24 for B+3

L268A:  DB      $0C
        DB      $BD,$74       ; 189 for C+1
        DB      $B2,$C7       ; 178 for C+S+1
        DB      $5E,$75       ; 94 for C+2
        DB      $59,$C8       ; 89 for C+S+2
        DB      $2E,$76       ; 46 for C+3
        DB      $2C,$C9       ; 44 for C+S+3
        DB      $17,$77       ; 23 for C+4
        DB      $15,$CA       ; 21 for C+S+4
        DB      $0B,$78       ; 11 for C+5
        DB      $0A,$CB       ; 10 for C+S+5
        DB      $06,$79       ; 6 for C+6
        DB      $02,$7A       ; 2 for C+7

L26A3:  DB      $0A
        DB      $A8,$75       ; 168 for D+1
        DB      $9F,$C8       ; 159 for D+S+1
        DB      $54,$76       ; 84 for D+2
        DB      $4F,$C9       ; 79 for D+S+2
        DB      $29,$77       ; 41 for D+3
        DB      $27,$CA       ; 39 for D+S+3
        DB      $14,$78       ; 20 for D+4
        DB      $13,$CB       ; 19 for D+S+4
        DB      $09,$CC       ; 9 for D+S+5
        DB      $05,$CD       ; 5 for D+S+6

L26B8:  DB      $04
        DB      $96,$76       ; 150 for E+1
        DB      $4A,$77       ; 74 for E+2
        DB      $25,$78       ; 37 for E+3
        DB      $12,$79       ; 18 for E+4

L26C1:  DB      $09
        DB      $8D,$77       ; 141 for F+1
        DB      $85,$CA       ; 133 for F+S+1
        DB      $46,$78       ; 70 for F+2
        DB      $42,$CB       ; 66 for F+S+2
        DB      $22,$79       ; 34 for F+3
        DB      $21,$CC       ; 33 for F+S+3
        DB      $11,$7A       ; 17 for F+4
        DB      $10,$CD       ; 16 for F+S+4
        DB      $08,$7B       ; 8 for F+5

L26D4:  DB      $0E
        DB      $FD,$77       ; 253 for G+0
        DB      $EE,$CA       ; 238 for G+S+0
        DB      $7E,$78       ; 126 for G+1
        DB      $77,$CB       ; 119 for G+S+1
        DB      $3E,$79       ; 62 for G+2
        DB      $3B,$CC       ; 59 for G+S+2
        DB      $1F,$7A       ; 31 for G+3
        DB      $1D,$CD       ; 29 for G+S+3
        DB      $0F,$7B       ; 15 for G+4
        DB      $0E,$CE       ; 14 for G+S+4
        DB      $07,$7C       ; 7 for G+5
        DB      $04,$7D       ; 4 for G+6
        DB      $01,$7E       ; 1 for G+7
        DB      $00,$7F       ; 0 for G+8

; ********************* At End of Text Buffer Analize subroutine
L26F1:  POP     HL            ; dump Get Character return address
        LD      HL,L4F38      ; Work Area #2 counter
        LD      A,(HL)
L26F6:  LD      C,A
        CP      $00           ; is Work Area #2 empty ?
        JP      Z,L275F       ; then Play Music Score
        SLA     A
        DEC     HL            ; else counter times 2 - 1
        LD      E,A
        LD      D,$00
        ADD     HL,DE         ; point to Work Area #2 slot
        LD      E,(HL)
        INC     HL
        LD      D,(HL)        ; read old Score Pointer
        LD      A,(DE)        ; read old Score command data
        INC     DE
        PUSH    DE            ; store next Score Pointer
        CP      $D0           ; was it NOT a Call Relative ?
        JR      NZ,L2741                ; (+$34)
; ********************* Handle a Relative Call continued
        LD      HL,L4F19      ; Work Area #1 counter
        LD      E,(HL)
        LD      D,$00
        SLA     E
        DEC     E             ; counter times 2 - 1
        ADD     HL,DE
        PUSH    HL            ; store Work Area #1 slot pointer
        SRA     E
        LD      HL,L4F19      ; save Work Area #1 counter - 1
        LD      (HL),E
        POP     HL            ; restore Work Area #1 slot pointer
        LD      E,(HL)
        INC     HL
        LD      D,(HL)        ; point at old Text Character ID location
        CALL    L274F         ; to Scan through Work Area #3
        LD      E,(HL)
        INC     HL
        LD      D,(HL)        ; point at Label address that matches ID
        POP     HL            ; restore next Score Pointer
        PUSH    HL            ; re-store next Score Pointer
        EX      DE,HL         ; swap for subtract
        JR      NC,L272E                ; (+$01)
        CCF                   ; (always clear Carry flag)
L272E:  SBC     HL,DE
        LD      A,L           ; get relative difference
        POP     HL            ; restore next Score Pointer again
        DEC     HL            ; ... but back up to Current location
        LD      B,(HL)
        AND     $0F
        OR      B
        LD      (HL),A        ; save as bbbbAAAA for $Dx and finish
; ********************* Handle a Relative or Absolute Call finish
L2738:  LD      A,C
        DEC     A
        LD      HL,L4F38      ; save Work Area #2 counter - 1
        LD      (HL),A
        JP      L26F6         ; Loop Back for Next Call to Handle

; ********************* Handle an Absolute Call, Jump or DSJNZ continued
L2741:  CALL    L274F         ; to Scan through Work Area #3
        LD      E,(HL)
        INC     HL
        LD      D,(HL)        ; point at Label address that matches ID
        POP     HL            ; restore next Score Pointer
        LD      (HL),E
        INC     HL
        LD      (HL),D        ; save Label address at pointer location 
        INC     HL
        JP      L2738         ; ... and finish

; ********************* Scan through Work Area #3 for ID subroutine
L274F:  LD      HL,L4F7F      ; Work Area #3 base
        LD      B,(HL)        ; get Work Area #3 slot counter
        INC     HL            ; point to ID of first slot
        LD      A,(DE)        ; read ID from saved Score Pointer
L2755:  CP      (HL)          ; got a match ?
        INC     HL
        RET     Z             ; Yes, return
        INC     HL
        INC     HL            ; No, keep looking
        DJNZ    L2755                   ; (-$07)
        POP     DE            ; on NO MATCH found
        POP     HL
        RET                   ; ... do WHAT Now ??

; ********************* Play Music Score routine on Key Down = '='
L275F:  LD      IX,L4938      ; Top of Music Stack
        LD      HL,L4D4A      ; Music Score
        LD      A,(L4D49)     ; Voices to start with
        SYSTEM  BMUSIC

        LD      A,(L4F18)
        BIT     1,A           ; was Music Score UN-analyzed ?
        JR      Z,L2778                 ; (+$06)
        LD      HL,(L4F0B)    ; restore Text Character pointer
        LD      (L4F12),HL    ; ... to pre-analysis location
L2778:  SET     7,A           ; mark flag for Text Editor mode
        RES     1,A           ; mark Music Score UN-analyzed
        LD      (L4F18),A
        RET

; ********************* End of Z80 Source Code
; 128 bytes of 255's filler to match source ROM
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
        DB      $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

				; $27FF = End of Code
